(function(exports) {
var response_lenght = 10;
var queryTimeout = 3000;
var access_commands = [
{"name": l100n.localize_string("access_control_on"), "command": "0x10000"},
{"name": l100n.localize_string("access_control_off"), "command": "0x20000"},
{"name": l100n.localize_string("access_level_reset"), "command": "0x30000"},
{"name": l100n.localize_string("change_password"), "command": "0x40000"},
{"name": l100n.localize_string("download_settings"), "command": "0x00050000"},
{"name": l100n.localize_string("upload_settings"), "command": "0x00060000"},
{"name": l100n.localize_string("reboot"), "command": "0x746f6f62"}
];
var access_values = [
{"new_value": l100n.localize_string("off"), "raw_value": "0"},
{"new_value": l100n.localize_string("user"), "raw_value": "1"},
{"new_value": l100n.localize_string("admin"), "raw_value": "2"}
];
var default_checkbox_values = [
{"new_value": l100n.localize_string("off"), "raw_value": "0"},
{"new_value": l100n.localize_string("on"), "raw_value": "1"}
];
var on_off_values = [
{"name": l100n.localize_string("off"), "command": "0"},
{"name": l100n.localize_string("on"), "command": "1"}
];
var baudrate = [
{"name": l100n.localize_string("9.6"), "command": "9600"},
{"name": l100n.localize_string("19.2"), "command": "19200"},
{"name": l100n.localize_string("38.4"), "command": "38400"},
{"name": l100n.localize_string("57.6"), "command": "57600"},
{"name": l100n.localize_string("115.2"), "command": "115200"}
];
var CAN_speed = [
{"name": "50", "command": "50000"},
{"name": "100", "command": "100000"},
{"name": "125", "command": "125000"},
{"name": "250", "command": "250000"},
{"name": "500", "command": "500000"},
{"name": "800", "command": "800000"},
{"name": "1000", "command": "1000000"}
];
var parity = [
{"name": l100n.localize_string("off"), "command": "0"},
{"name": l100n.localize_string("even"), "command": "1"},
{"name": l100n.localize_string("odd"), "command": "2"}
];
var stopbits = [
{"name": "1", "command": "1"},
{"name": "2", "command": "2"}
];
var line_mode = [
{"name": l100n.localize_string("Heater Off"), "command": "0"},
{"name": l100n.localize_string("Heater On"), "command": "1"},
{"name": l100n.localize_string("Remote"), "command": "2"},
{"name": l100n.localize_string("PWM"), "command": "3"},
{"name": l100n.localize_string("Temp Relay"), "command": "4"},
{"name": l100n.localize_string("PWM Proportional"), "command": "5"},
];
var line_mode_status = [
{"new_value": l100n.localize_string("Heater Off"), "raw_value": "0"},
{"new_value": l100n.localize_string("Heater On"), "raw_value": "1"},
{"new_value": l100n.localize_string("Remote"), "raw_value": "2"},
{"new_value": l100n.localize_string("PWM"), "raw_value": "3"},
{"new_value": l100n.localize_string("Temp Relay"), "raw_value": "4"},
{"new_value": l100n.localize_string("PWM Proportional"), "raw_value": "5"},
{"new_value": l100n.localize_string("error_status"), "raw_value": "255"},
];
var temperature_mode = [
{"name": l100n.localize_string("off"), "command": "0"},
{"name": l100n.localize_string("First"), "command": "1"},
{"name": l100n.localize_string("Second"), "command": "2"},
{"name": l100n.localize_string("Average"), "command": "3"},
{"name": l100n.localize_string("Min"), "command": "4"},
{"name": l100n.localize_string("Max"), "command": "5"},
];
var sensors_number = [
{"name": l100n.localize_string("off"), "command": "0"},
{"name": "RTD 1", "command": "1"},
{"name": "RTD 2", "command": "2"},
{"name": "4-20mA 1", "command": "3"},
{"name": "4-20mA 2", "command": "4"},
];
var sensor_type = [
{"name": "М - 50", "command": "1"},
{"name": "Pt - 50", "command": "2"},
{"name": "Pt - 100", "command": "3"},
{"name": "П - 50", "command": "4"},
{"name": "П - 100", "command": "5"}
];
exports.sensor_type_rtd = [
    {"name": "М - 50", "command": "1"},
    {"name": "Pt - 50", "command": "2"},
    {"name": "Pt - 100", "command": "3"},
    {"name": "П - 50", "command": "4"},
    {"name": "П - 100", "command": "5"}
];
exports.sensor_type_ai = [
    {"name": "0 - 20", "command": "0"},
    {"name": "4 - 20", "command": "200"},
];
var do_selector = [
{"name": l100n.localize_string("off"), "command": "0"},
{"name": "DO1", "command": "1"},
{"name": "DO2", "command": "2"},
{"name": "DO1+DO2", "command": "3"},
];
var ai_selector = [
{"name": l100n.localize_string("off"), "command": "0"},
{"name": "CTI 1", "command": "1"},
{"name": "CTI 2", "command": "2"},
];
var di_selector = [
{"name": l100n.localize_string("off"), "command": "0"},
{"name": "DI 1", "command": "1"},
{"name": "DI 2", "command": "2"},
{"name": "DI 3", "command": "3"},
{"name": "DI 4", "command": "4"},
{"name": "DI 5", "command": "5"},
];
var emergency_mode = [
{"name": l100n.localize_string("Heater Off"), "command": "0"},
{"name": l100n.localize_string("Heater On"), "command": "1"},
{"name": l100n.localize_string("PWM"), "command": "3"},
];
var line_command = [
{"name": l100n.localize_string("Trip Reset"), "command": "0x1FF"},
{"name": l100n.localize_string("Running Hours Reset"), "command": "0x2FF"},
{"name": l100n.localize_string("Switch On Counter Reset"), "command": "0x03FF"},
];
var yes_no_values = [
{"name": l100n.localize_string("no"), "command": "0"},
{"name": l100n.localize_string("yes"), "command": "1"}
];
var user_app_status = [
    {"new_value": l100n.localize_string("ua_absent"), "raw_value": "0"},
    {"new_value": l100n.localize_string("ua_start"), "raw_value": "1"},
    {"new_value": l100n.localize_string("ua_stop"), "raw_value": "2"}
];
var data_type_template = {"templates": [
{"index": "2081_1","template": "datetime"},
{"index": "2002_1","template": "combobox", "commands": access_commands},
{"index": "2001_9","template": "change_value", "commands": access_values},
{"index": "2002_2","template": "password"},
{"index": "1018_3","template": "ip_addr"},
{"index": "2000_3","template": "ip_addr"},
{"index": "5000_3","template": "ip_addr"},
{"index": "2000_6","template": "ip_addr"},
{"index": "2213_2","template": "ip_addr"},
{"index": "2213_3","template": "ip_addr"},
{"index": "2213_4","template": "ip_addr"},
{"index": "2213_5","template": "ip_addr"},
{"index": "2213_6","template": "ip_addr"},
{"index": "2001_5","template": "battery"},
{"index": "2143_4","template": "combobox", "commands": parity},
{"index": "2143_5","template": "combobox", "commands": stopbits},
{"index": "2213_1","template": "combobox", "commands": on_off_values},
{"index": "2143_1","template": "combobox", "commands": yes_no_values},
{"index": "2143_2","template": "combobox", "commands": baudrate},
{"index": "2103_1","template": "combobox", "commands": yes_no_values},
{"index": "2103_2","template": "combobox", "commands": CAN_speed},
{"index": "1011_1","template": "restore_params"},
{"index": "4139_1","template": "combobox", "commands": sensor_type},
{"index": "4139_2","template": "combobox", "commands": sensor_type},
{"index": "4139_3","template": "combobox", "commands": sensor_type},
{"index": "4139_4","template": "combobox", "commands": sensor_type},
{"index": "4139_5","template": "combobox", "commands": sensor_type},
{"index": "4139_6","template": "combobox", "commands": sensor_type},
{"index": "4139_7","template": "combobox", "commands": sensor_type},
{"index": "4139_8","template": "combobox", "commands": sensor_type},
{"index": "5801_2","template": "change_value", "commands": line_mode_status},
{"index": "5821_3","template": "combobox", "commands": line_mode},
{"index": "5820_1","template": "combobox", "commands": line_command},
{"index": "5821_7","template": "combobox", "commands": temperature_mode},
{"index": "582B_3","template": "combobox", "commands": sensors_number},
{"index": "582B_4","template": "combobox", "commands": sensors_number},
{"index": "582B_2","template": "combobox", "commands": do_selector},
{"index": "582B_5","template": "combobox", "commands": ai_selector},
{"index": "582B_6","template": "combobox", "commands": ai_selector},
{"index": "582B_7","template": "combobox", "commands": di_selector},
{"index": "582B_8","template": "combobox", "commands": di_selector},
{"index": "582B_9","template": "combobox", "commands": di_selector},
{"index": "5821_4","template": "combobox", "commands": emergency_mode},
{"index": "5841_2","template": "change_value", "commands": line_mode_status},
{"index": "5861_3","template": "combobox", "commands": line_mode},
{"index": "5860_1","template": "combobox", "commands": line_command},
{"index": "5861_7","template": "combobox", "commands": temperature_mode},
{"index": "586B_3","template": "combobox", "commands": sensors_number},
{"index": "586B_4","template": "combobox", "commands": sensors_number},
{"index": "586B_2","template": "combobox", "commands": do_selector},
{"index": "586B_5","template": "combobox", "commands": ai_selector},
{"index": "586B_6","template": "combobox", "commands": ai_selector},
{"index": "586B_7","template": "combobox", "commands": di_selector},
{"index": "586B_8","template": "combobox", "commands": di_selector},
{"index": "586B_9","template": "combobox", "commands": di_selector},
{"index": "5861_4","template": "combobox", "commands": emergency_mode},
{"index": "5001_1","template": "change_value", "commands": user_app_status},
{"index": "5000_2","template": "datetime_simple"},
{"index": "5000_3","template": "ip_addr"},
]};
exports.add_template = function(template)
{ 
    data_type_template.templates.push(template)
}
exports.response_lenght = function() { return response_lenght;}
exports.queryTimeout = function() { return queryTimeout;}
exports.data_type_template = function() { return data_type_template;}
exports.default_checkbox_values = function() { return default_checkbox_values;}
})(this.configuration = {});
