var get_board_type_xhr = new XMLHttpRequest();
var board_types = {reserved: 0, hdi: 1, di: 2, ai: 3, cti: 4, rtd: 5, ao: 7, ro: 8, hdo: 9
	, io1: 10, em_h: 16, em_l: 17, io3:18, hdi_5: 11, deleted: 255}
var selected_accordion = 0;

function form_tag_tr(param_name, eds_index, eds_subindex)
{
    return form_tag_tr_param({name: param_name, index: eds_index, sub: eds_subindex})
}

function form_tag_tr_param(param)
{
    var tr = $('<tr class="can_hide">').append($('<td>').text(param.name))//.addClass("name"));
	var div = $('<div>').addClass("tag").attr({"index": `${param.index.toString(16).toUpperCase()}:${param.sub}`});
    tr.append($('<td>').append(div))//.addClass("name"));
    return tr;
}

function form_tag_tr2(param_name, eds_index, eds_subindex, param_name2, eds_index2, eds_subindex2)
{
	return form_tag_tr2_param({name: param_name, index: eds_index, sub: eds_subindex, type: ""},
							{name: param_name2, index: eds_index2, sub: eds_subindex2, type: ""})
}

function form_tag_tr2_param(param1, param2)
{
    var tr = $('<tr class="can_hide">').append($('<td>').text(param1.name))//.addClass("name"));
	var div = $('<div>').addClass("tag").attr({"index": `${param1.index.toString(16).toUpperCase()}:${param1.sub}`});
	if ("type" in param1) 
	{
		div.addClass(param1.type)
	}
    tr.append($('<td>').append(div))//.addClass("name"));
	//tr.append($('<td>'))//.addClass('empty_space'));
	if (param2.name != "")
	{
		tr.append($('<td>').text(param2.name).addClass("name"));
	}
    
	var div2 = $('<div>').addClass("tag").attr({"index": `${param2.index.toString(16).toUpperCase()}:${param2.sub}`});
	if ("type" in param2) 
	{
		div2.addClass(param2.type)
	}
    tr.append($('<td>').append(div2))//.addClass("name"));
    return tr;
}

function form_name_tr(param_name)
{
    return $('<tr class="can_hide">').append($('<td>').text(param_name).addClass("name")).append($('<td>'));
}

function form_tag_divide_tr(param_name, eds_index_num, eds_subindex_num, eds_index_den, eds_subindex_den)
{
    var tr = $('<tr class="can_hide">').append($('<td>').text(param_name).addClass("name"));
    var table = $('<table>');
    var div1 = $('<div>').addClass("io").addClass("tag").attr({"index": `${eds_index_num.toString(16).toUpperCase()}:${eds_subindex_num}`});
    var div2 = $('<div>').addClass("io").addClass("tag").attr({"index": `${eds_index_den.toString(16).toUpperCase()}:${eds_subindex_den}`});
    table.append($('<tr>').append(($('<td style="border-bottom-color: black">').append(div1))))
    table.append($('<tr>').append(($('<td>').append(div2))))
    tr.append($('<td>').append(table));
    return tr;
}

function form_multy_tag_tr(param_name, eds_index, count, start_index=1)
{
    var tr = $('<tr class="can_hide">').append($('<td>').text(param_name).addClass("name"));
    for (var eds_subindex = start_index; eds_subindex < start_index+count; eds_subindex++)
    {
        var div = $('<div>').addClass("io").addClass("tag").attr({"index": `${eds_index.toString(16).toUpperCase()}:${eds_subindex}`});
        tr.append($('<td>').append(div));
    }
    return tr;
}

function form_multy_header(param_name, count)
{
    var tr = $('<tr class="table_header">').append($('<td>').text(param_name).addClass("name"));
    for (var eds_subindex = 1; eds_subindex < count+1; eds_subindex++)
    {
        var div = $('<div>').text(eds_subindex);
        tr.append($('<td>').append(div));
    }
    return tr;
}

function create_block(element, data)
{
    var tr = $('<tr>')
    $.each(data.blocks, function(block_index, block_item)
    {
        var table_inner = $('<table>');
        $.each(block_item.params, function(param_index, param_item)
        {
            if (param_item.index != null && param_item.sub != null)
            {
                table_inner.append(form_tag_tr(param_item.name, param_item.index, param_item.sub));
            }
            else
            {
                table_inner.append(form_name_tr(param_item.name));
            }
        })
        td = $('<td>').append(table_inner)
        td_empty_space = $('<td>').addClass("empty_space")
        tr.append(td).append(td_empty_space)
    })

    element.append($('<table>').append(tr));
}

$(document).ready(function()
{
	//board 0
	var board_index = "0x3F01"
	var board_status = $('<div>').addClass('tag').addClass('board_status').attr({"index": `${board_index}:1`}).hide()
	var board_body = $('<div>').addClass("accordion-body").append(board_status);
	var board_div = $('<div>').addClass("board").attr({"id": `board_0`}).append(board_body);
	$("#board_head").append(board_div);

	var query = '/get_od_data.form?';
	query += `0x1027_1`; //board type

    var start_number = 1;
    var end_number = 9;
    for (var board_number = start_number; board_number <= end_number; board_number++)
    {
        if (board_number >= start_number)
        {
            query += "&";
        }
        query += `0x1027_${(board_number)}`; //board type
    }
    get_board_type_xhr.open('GET', query, true);
	get_board_type_xhr.send();

	$("#heating_lines").append(get_heat_lines_header(1));
	$("#heating_lines").append(get_heat_lines_body(1));
	$("#heating_lines").append(get_heat_lines_header(2));
	$("#heating_lines").append(get_heat_lines_body(2));

    //$("#boyan").accordion({ heightStyle: 'content', header: '.accordion-header', active: 0});
    //$("#boyan").accordion( "option", "collapsible", true );
});

function show_boards_by_type(types)
{
$("#io_settings").append('<h3 id="Boards_Settings">I/O Boards Settings</h3>');
for (var board_number = 0; board_number < 9; board_number++)
{
//console.log("board_number "+board_number);
//console.log("types[board_number] "+types[board_number])
if (types[board_number] != null)
{
    var type = types[board_number].replace(/\u0000/g, '');
	
	if (board_number > 0)
    {
        var board_index = (0x4001 + (board_number - 1)*0x100).toString(16).toUpperCase()
        var board_div = $('<div>').addClass("board").attr({"id": `board_${board_number}`})
		var board_name = `${l100n.localize_string("module")} ${board_number}`
		var board_name_div = $('<div>').text(board_name).addClass('board_name')
		var empty_div = $('<div>').addClass('empty_space').addClass('board_name')
		var eds_index = 0x4000 + (board_number - 1)*0x100;
		//var board_code = $('<div>').addClass("tag").attr({"index": `${eds_index.toString(16).toUpperCase()}:1`}).addClass('board_name')
		if (type == board_types.io1)
		{
			var board_code = l100n.localize_string("Discret I/O")
		}
		else if (type == board_types.io3)
		{
			var board_code = l100n.localize_string("Analog Inputs")
		}

		/*$.each(configuration.module_types(), function(index, item)
		{
			if (item.command == type)
			{
				board_code = item.name
			}
		})*/
		var board_name_table = $('<div>').append(board_name_div).append(empty_div).append(board_code).addClass('board_name')
        var board_head = $('<div>').append(board_name_table).addClass("accordion-header").attr({"status_index": `${board_index}:1`})
        var board_body = $('<div>').addClass("accordion-body");

        var board_status = $('<div>').addClass('tag').addClass('board_status').attr({"index": `${board_index}:1`}).hide()
        board_body.append(board_status);
        board_div.append(board_head);
        board_div.append(board_body);
        $("#io_settings").append(board_div);
    }

    if (type == board_types.deleted)
    {
		$(`#board_${board_number}`).hide();
    }
    else if (type == board_types.io3)
	{
		var main_div = $('<div>').addClass('tab-class');
		ul=$('<ul>')
		ul.append($('<li>').append($('<a>').prop('href',`#rtd-tab-${board_number}`).append("RTD")))
		ul.append($('<li>').append($('<a>').prop('href',`#cti-tab-${board_number}`).append("CTI")))
		ul.append($('<li>').append($('<a>').prop('href',`#ai-tab-${board_number}`).append("AI")))
		main_div.append(ul)

		tab_table = $('<table>')
		tab_table.append(ai_tab(board_number))
		tab_table.append(cti_tab(board_number))
		tab_table.append(rtd_tab(board_number))

	    main_div.append(tab_table)
	    $(`#board_${board_number}`).children('.accordion-body').append(main_div);
	}
	else if (type == board_types.io1) 
	{
		var main_div = $('<div>').addClass('tab-class');
		ul=$('<ul>')
		ul.append($('<li>').append($('<a>').prop('href',`#di-tab-${board_number}`).append("DI")))
		ul.append($('<li>').append($('<a>').prop('href',`#do-tab-${board_number}`).append("DO")));
		ul.append($('<li>').append($('<a>').prop('href',`#alarm-tab-${board_number}`).append("Alarm")));
		main_div.append(ul)

		tbody_alarm = $('<tbody>').prop('id',`alarm-tab-${board_number}`).addClass('nowrap_td').addClass('data_td')
		var tbody_alarm_header = $('<tr>').addClass('table_header')
		tbody_alarm_header.append($('<td colspan="1">').text(l100n.localize_string("Alarm relay")))
		tbody_alarm_header.append($('<td colspan="1">'))
		tbody_alarm.append(tbody_alarm_header)
		tbody_alarm.append(form_tag_tr(l100n.localize_string("value"), 0x3F21 + 0 * 0x100, 1));
		tbody_alarm.append(form_tag_tr(l100n.localize_string("invert_polarity"), 0x3F22 + 0 * 0x100, 1));
		/*tbody_alarm.append(form_tag_tr(l100n.localize_string("Error mode"), 0x3F23 + 0 * 0x100, 1));
		tbody_alarm.append(form_tag_tr(l100n.localize_string("Error value"), 0x3F24 + 0 * 0x100, 1));
		tbody_alarm.append(form_tag_tr(l100n.localize_string("Filter mask"), 0x3F25 + 0 * 0x100, 1));*/

		tab_table = $('<table>')
		tab_table.append(tbody_alarm)
		tab_table.append(do_tab(board_number));
		tab_table.append(di_tab(board_number));

		main_div.append(tab_table);
		$(`#board_${board_number}`).children('.accordion-body').append(main_div);
	}	
}
else
{
    $(`#board_${board_number}`).hide();
}
}
}

function ai_tab(board_number)
{
	var count = 2
	var start_index = 5

	var ul = $('<ul>')
	ul.append($(`<li><a href="#ai_value-tab${board_number}">${l100n.localize_string("input state")}</a></li>`))	
	ul.append($(`<li><a href="#settings-tab${board_number}">${l100n.localize_string("Settings")}</a></li>`))
	ul.append($(`<li><a href="#ai_scaling-tab${board_number}">${l100n.localize_string("Scaling")}</a></li>`))
	ul.append($(`<li><a href="#ai_deadband_settings-tab${board_number}">${l100n.localize_string("Deadband Settings")}</a></li>`))

	var ai_value = $(`<tbody id="ai_value-tab${board_number}">`).addClass('nowrap_td').addClass('data_td')
	var ai_scaling = $(`<tbody id="ai_scaling-tab${board_number}">`).addClass('nowrap_td').addClass('data_td')
	var settings = $(`<tbody id="settings-tab${board_number}">`).addClass('nowrap_td').addClass('data_td')
	var ai_deadband_settings = $(`<tbody id="ai_deadband_settings-tab${board_number}">`).addClass('nowrap_td').addClass('data_td')
	
	ai_value.append($('<tr>').addClass('table_header').append($('<td colspan="1">')).append($('<td colspan="1">').text(l100n.localize_string("value"))))
	//settings.append($('<tr>').addClass('table_header').append($('<td colspan="1">')).append($('<td colspan="1">').text(l100n.localize_string("Filter time, ms"))))

	var deadband_head = $('<tr>').addClass('table_header');
	deadband_head.append($('<td colspan="1">').text(""));
	deadband_head.append($('<td colspan="1">').text(l100n.localize_string("Deadband Reference")));
	deadband_head.append($('<td colspan="1">').text(l100n.localize_string("Deadband, %")))
	ai_deadband_settings.append(deadband_head)
	var ai_scaling_head = $('<tr>').addClass('table_header').append($('<td colspan="1">').text(""));
	ai_scaling_head.append($('<td colspan="1">').text(l100n.localize_string("Scaling")));
	ai_scaling_head.append($('<td colspan="1">').text(l100n.localize_string("Offset")))
	ai_scaling.append(ai_scaling_head)
	var settings_head = $('<tr>').addClass('table_header').append($('<td colspan="1">').text(""));
	settings_head.append($('<td colspan="1">').text(l100n.localize_string("Input Sensor")));
	settings_head.append($('<td colspan="1">').text(l100n.localize_string("Filter time, ms")))
	settings.append(settings_head)

	for (var eds_subindex = start_index; eds_subindex < start_index+count; eds_subindex++)
	{
		var eds_index = 0x3F39 + board_number*0x100
		configuration.add_template({"index": `${eds_index.toString(16).toUpperCase()}_${eds_subindex}`,"template": "combobox", "commands": configuration.sensor_type_ai})

		ai_value.append(form_tag_tr(`${eds_subindex - start_index + 1}`, 0x3F31 + board_number*0x100, eds_subindex));
		ai_scaling.append(form_tag_tr2(`${eds_subindex - start_index + 1}`, 0x3F32 + board_number*0x100, eds_subindex, "", 0x3F33 + board_number*0x100, eds_subindex));
		settings.append(form_tag_tr2(`${eds_subindex - start_index + 1}`, 0x3F39 + board_number*0x100, eds_subindex, "", 0x3F34 + board_number*0x100, eds_subindex));
		ai_deadband_settings.append(form_tag_tr2(`${eds_subindex - start_index + 1}`, 0x3F3C + board_number*0x100, eds_subindex, "", 0x3F35 + board_number*0x100, eds_subindex));
	}

	var table = $('<table>').append(ai_value).append(ai_deadband_settings).append(settings).append(ai_scaling)//.append(ai_deadband)
	var tabs_div = $('<div class="tab-class">').append(ul).append(table)
	tbody_ai = $('<tbody>').prop('id',`ai-tab-${board_number}`).append(tabs_div)
	return tbody_ai
}

function rtd_tab(board_number)
{
	var count = 2
	var start_index = 7

	var ul = $('<ul>')
		ul.append($(`<li><a href="#value-tab${board_number}">${l100n.localize_string("input state")}</a></li>`))
		ul.append($(`<li><a href="#scaling-tab${board_number}">${l100n.localize_string("Scaling")}</a></li>`))
		ul.append($(`<li><a href="#deadband_settings-tab${board_number}">${l100n.localize_string("Deadband Settings")}</a></li>`))
		ul.append($(`<li><a href="#settings-tab${board_number}">${l100n.localize_string("Settings")}</a></li>`))

		var value = $(`<tbody id="value-tab${board_number}">`).addClass('nowrap_td').addClass('data_td')
		var scaling = $(`<tbody id="scaling-tab${board_number}">`).addClass('nowrap_td').addClass('data_td')
		var deadband_settings = $(`<tbody id="deadband_settings-tab${board_number}">`).addClass('nowrap_td').addClass('data_td')
		var settings = $(`<tbody id="settings-tab${board_number}">`).addClass('nowrap_td').addClass('data_td')
		
		value.append($('<tr>').addClass('table_header').append($('<td colspan="1">')).append($('<td colspan="1">').text(l100n.localize_string("value"))))
		//filter_time.append($('<tr>').addClass('table_header').append($('<td colspan="2">').text(l100n.localize_string("Filter time, ms"))))
		//settings.append($('<tr>').addClass('table_header').append($('<td colspan="2">').text(l100n.localize_string("Input Sensor"))))
	
		var deadband_head = $('<tr>').addClass('table_header');
		deadband_head.append($('<td colspan="1">').text(""));
	    deadband_head.append($('<td colspan="1">').text(l100n.localize_string("Deadband Reference")));
		deadband_head.append($('<td colspan="1">').text(l100n.localize_string("Deadband, %")))
		deadband_settings.append(deadband_head)
		var scaling_head = $('<tr>').addClass('table_header').append($('<td colspan="1">').text(""));
	    scaling_head.append($('<td colspan="1">').text(l100n.localize_string("Scaling")));
		scaling_head.append($('<td colspan="1">').text(l100n.localize_string("Offset")))
		scaling.append(scaling_head)
		var settings_head = $('<tr>').addClass('table_header').append($('<td colspan="1">').text(""));
	    settings_head.append($('<td colspan="1">').text(l100n.localize_string("Input Sensor")));
		settings_head.append($('<td colspan="1">').text(l100n.localize_string("Filter time, ms")))
		settings.append(settings_head)

		for (var eds_subindex = start_index; eds_subindex < start_index+count; eds_subindex++)
		{
			var eds_index = 0x3F39 + board_number*0x100
			configuration.add_template({"index": `${eds_index.toString(16).toUpperCase()}_${eds_subindex}`, "template": "combobox", "commands": configuration.sensor_type_rtd})
			value.append(form_tag_tr(`${eds_subindex - start_index + 1}`, 0x3F31 + board_number*0x100, eds_subindex));
			scaling.append(form_tag_tr2(`${eds_subindex - start_index + 1}`, 0x3F32 + board_number*0x100, eds_subindex, "", 0x3F33 + board_number*0x100, eds_subindex));
			deadband_settings.append(form_tag_tr2(`${eds_subindex - start_index + 1}`, 0x3F3C + board_number*0x100, eds_subindex, "", 0x3F35 + board_number*0x100, eds_subindex));
			settings.append(form_tag_tr2(`${eds_subindex - start_index + 1}`, 0x3F39 + board_number*0x100, eds_subindex, "", 0x3F34 + board_number*0x100, eds_subindex));
		}

		var table = $('<table>')
		table.append(value).append(scaling).append(deadband_settings).append(settings)
		var tabs_div = $('<div class="tab-class">').append(ul).append(table)
		var tbody_rtd = $('<tbody>').prop('id',`rtd-tab-${board_number}`).append(tabs_div)
		return tbody_rtd
}

function cti_tab(board_number)
{
	var count = 2
	var start_index = 1

	var ul = $('<ul>')
	ul.append($(`<li><a href="#ai_value-tab${board_number}">${l100n.localize_string("input state")}</a></li>`))	
	ul.append($(`<li><a href="#settings-tab${board_number}">${l100n.localize_string("Settings")}</a></li>`))
	ul.append($(`<li><a href="#ai_scaling-tab${board_number}">${l100n.localize_string("Scaling")}</a></li>`))
	ul.append($(`<li><a href="#ai_deadband_settings-tab${board_number}">${l100n.localize_string("Deadband Settings")}</a></li>`))

	var ai_value = $(`<tbody id="ai_value-tab${board_number}">`).addClass('nowrap_td').addClass('data_td')
	var ai_scaling = $(`<tbody id="ai_scaling-tab${board_number}">`).addClass('nowrap_td').addClass('data_td')
	var settings = $(`<tbody id="settings-tab${board_number}">`).addClass('nowrap_td').addClass('data_td')
	var ai_deadband_settings = $(`<tbody id="ai_deadband_settings-tab${board_number}">`).addClass('nowrap_td').addClass('data_td')
	
	ai_value.append($('<tr>').addClass('table_header').append($('<td colspan="1">')).append($('<td colspan="1">').text(l100n.localize_string("value"))))
	//settings.append($('<tr>').addClass('table_header').append($('<td colspan="1">')).append($('<td colspan="1">').text(l100n.localize_string("Filter time, ms"))))

	var deadband_head = $('<tr>').addClass('table_header');
	deadband_head.append($('<td colspan="1">').text(""));
	deadband_head.append($('<td colspan="1">').text(l100n.localize_string("Deadband Reference")));
	deadband_head.append($('<td colspan="1">').text(l100n.localize_string("Deadband, %")))
	ai_deadband_settings.append(deadband_head)
	var ai_scaling_head = $('<tr>').addClass('table_header').append($('<td colspan="1">').text(""));
	ai_scaling_head.append($('<td colspan="1">').text(l100n.localize_string("Scaling")));
	ai_scaling_head.append($('<td colspan="1">').text(l100n.localize_string("Offset")))
	ai_scaling.append(ai_scaling_head)
	var settings_head = $('<tr>').addClass('table_header').append($('<td colspan="1">').text(""));
	//settings_head.append($('<td colspan="1">').text(l100n.localize_string("Input Sensor")));
	settings_head.append($('<td colspan="1">').text(l100n.localize_string("Filter time, ms")))
	settings.append(settings_head)

	for (var eds_subindex = start_index; eds_subindex < start_index+count; eds_subindex++)
	{
		var eds_index = 0x3F39 + board_number*0x100
		configuration.add_template({"index": `${eds_index.toString(16).toUpperCase()}_${eds_subindex}`,"template": "combobox", "commands": configuration.sensor_type_ai})

		ai_value.append(form_tag_tr(`${eds_subindex}`, 0x3F31 + board_number*0x100, eds_subindex));
		ai_scaling.append(form_tag_tr2(`${eds_subindex}`, 0x3F32 + board_number*0x100, eds_subindex, "", 0x3F33 + board_number*0x100, eds_subindex));
		settings.append(form_tag_tr(`${eds_subindex}`, 0x3F34 + board_number*0x100, eds_subindex));
		ai_deadband_settings.append(form_tag_tr2(`${eds_subindex}`, 0x3F3C + board_number*0x100, eds_subindex, "", 0x3F35 + board_number*0x100, eds_subindex));
	}

	var table = $('<table>')
	table.append(ai_value).append(ai_deadband_settings).append(settings).append(ai_scaling)//.append(ai_deadband)
	var tabs_div = $('<div class="tab-class">').append(ul).append(table)
	var tbody_cti = $('<tbody>').prop('id',`cti-tab-${board_number}`).append(tabs_div)
	return tbody_cti
}

function do_tab(board_number)
{
	count = 2;
	var start_index = 1
	
	var ul = $('<ul>')
	ul.append($(`<li><a href="#value-tab${board_number}">${l100n.localize_string("output state")}</a></li>`))
	ul.append($(`<li><a href="#invert_polarity-tab${board_number}">${l100n.localize_string("Settings")}</a></li>`))
	//ul.append($(`<li><a href="#error_mode-tab${board_number}">${l100n.localize_string("Error mode")}</a></li>`))
	//ul.append($(`<li><a href="#filter_mask-tab${board_number}">${l100n.localize_string("Filter mask")}</a></li>`))

	var value_tab = $(`<tbody id="value-tab${board_number}">`).addClass('nowrap_td').addClass('data_td')
	var invert_polarity_tab = $(`<tbody id="invert_polarity-tab${board_number}">`).addClass('nowrap_td').addClass('data_td')
	var error_mode_tab = $(`<tbody id="error_mode-tab${board_number}">`).addClass('nowrap_td').addClass('data_td')
	var filter_mask_tab = $(`<tbody id="filter_mask-tab${board_number}">`).addClass('nowrap_td').addClass('data_td')
	
	var value_header = $('<tr>').addClass('table_header')
	value_header.append($('<td colspan="1">'))//.text(l100n.localize_string("Channel:")))
	value_header.append($('<td colspan="1">').text(l100n.localize_string("value")))
	value_header.append($('<td colspan="1">').text(l100n.localize_string("invert_polarity")))
	value_tab.append(value_header)
	var error_mode_header = $('<tr>').addClass('table_header')
	error_mode_header.append($('<td colspan="1">'))
	error_mode_header.append($('<td colspan="1">').text(l100n.localize_string("Error value")))
	error_mode_header.append($('<td colspan="1">').text(l100n.localize_string("Error mode")))
	error_mode_tab.append(error_mode_header)
	invert_polarity_tab.append($('<tr>').addClass('table_header').append($('<td colspan="1">')).append($('<td colspan="1">').text(l100n.localize_string("invert_polarity"))))
	filter_mask_tab.append($('<tr>').addClass('table_header').append($('<td colspan="1">')).append($('<td colspan="1">').text(l100n.localize_string("Filter mask"))))

	for (var eds_subindex = start_index; eds_subindex < start_index+count; eds_subindex++)
	{
		var value_params = {name: `${eds_subindex}`, index: 0x3F21 + board_number*0x100, sub: eds_subindex}
		var invert_params = {name: "", index: 0x3F22 + board_number*0x100, sub: eds_subindex, type: "ro"}
		value_tab.append(form_tag_tr2_param(value_params, invert_params));
		invert_polarity_tab.append(form_tag_tr(`${eds_subindex}`, 0x3F22 + board_number*0x100, eds_subindex));
		var error_value_params = {name: `${eds_subindex}`, index: 0x3F24 + board_number*0x100, sub: eds_subindex}
		var error_mode_params = {name: "", index: 0x3F23 + board_number*0x100, sub: eds_subindex}
		
		error_mode_tab.append(form_tag_tr2_param(error_value_params, error_mode_params));
		filter_mask_tab.append(form_tag_tr(`${eds_subindex}`, 0x3F25 + board_number*0x100, eds_subindex));
	}

	var table = $('<table>')
	table.append(value_tab).append(invert_polarity_tab)//.append(filter_mask_tab)//.append(error_mode_tab)
	var tabs_div = $('<div class="tab-class">').append(ul).append(table)
	var tbody_do = $('<tbody>').prop('id',`do-tab-${board_number}`).append(tabs_div)
	return tbody_do
}

function di_tab(board_number)
{
	var count = 5;
	var start_index = 1
	
	var di_ul = $('<ul>')
	di_ul.append($(`<li><a href="#value-tab_${board_number}">${l100n.localize_string("input state")}</a></li>`))
	di_ul.append($(`<li><a href="#settings-tab_${board_number}">${l100n.localize_string("Settings")}</a></li>`))

	var value_tab = $(`<tbody id="value-tab_${board_number}">`).addClass('nowrap_td').addClass('data_td')
	var settings_tab = $(`<tbody id="settings-tab_${board_number}">`).addClass('nowrap_td').addClass('data_td')

	var value_header = $('<tr>').addClass('table_header')
	value_header.append($('<td colspan="1">'))//.text(l100n.localize_string("Channel:")))
	value_header.append($('<td colspan="1">').text(l100n.localize_string("value")))
	value_header.append($('<td colspan="1">').text(l100n.localize_string("invert_polarity")))
	value_tab.append(value_header)

	var settings_header = $('<tr>').addClass('table_header')
	settings_header.append($('<td colspan="1">'))//.text(l100n.localize_string("Channel:")))
	settings_header.append($('<td colspan="1">').text(l100n.localize_string("invert_polarity")))
	settings_header.append($('<td colspan="1">').text(l100n.localize_string("Filter time, ms")))
	settings_tab.append(settings_header)
	/*invert_polarity_tab.append($('<tr>').addClass('table_header').append($('<td colspan="2">').text(l100n.localize_string("invert_polarity"))))
	filter_time_tab.append($('<tr>').addClass('table_header').append($('<td colspan="2">').text(l100n.localize_string("Filter time, ms"))))*/

	//ai_value.append(form_multy_header(l100n.localize_string("Channel:"), count));
	for (var eds_subindex = start_index; eds_subindex < start_index+count; eds_subindex++)
	{
		var value_params = {name: `${eds_subindex}`, index: 0x3F11 + board_number*0x100, sub: eds_subindex}
		var invert_params = {name: "", index: 0x3F12 + board_number*0x100, sub: eds_subindex, type: "ro"}
		value_tab.append(form_tag_tr2_param(value_params, invert_params));
		/*invert_polarity_tab.append(form_tag_tr(`${eds_subindex}`, 0x3F12 + board_number*0x100, eds_subindex));
		filter_time_tab.append(form_tag_tr(`${eds_subindex}`, 0x3F13 + board_number*0x100, eds_subindex));*/
		var invert2_params = {name: `${eds_subindex}`, index: 0x3F12 + board_number*0x100, sub: eds_subindex}
		var filter_time_params = {name: "", index: 0x3F13 + board_number*0x100, sub: eds_subindex}
		settings_tab.append(form_tag_tr2_param(invert2_params, filter_time_params));
	}

	var di_table = $('<table>')
	di_table.append(value_tab).append(settings_tab)
	var di_tabs_div = $('<div class="tab-class">').append(di_ul).append(di_table).tabs()
	var tbody_di = $('<tbody>').prop('id',`di-tab-${board_number}`).append(di_tabs_div)
	
	return tbody_di
}

function get_heat_lines_header(number)
{
	return $(`<div class="accordion-header">${l100n.localize_string("Line")} ${number}</div>`)
}

function get_heat_lines_body(number)
{
	var ul = $('<ul>')
	ul.append($(`<li><a href="#online-tab${number}">${l100n.localize_string("Live View")}</a></li>`))
	ul.append($(`<li><a href="#alarms-tab${number}">${l100n.localize_string("Alarms")}</a></li>`))
	ul.append($(`<li><a href="#alarm-settings-tab${number}">${l100n.localize_string("Alarm Settings")}</a></li>`))
	ul.append($(`<li><a href="#settings-tab${number}">${l100n.localize_string("Settings")}</a></li>`))
	ul.append($(`<li><a href="#hw-settings-tab${number}">${l100n.localize_string("HW Settings")}</a></li>`))
	var online_tbody = $(`<tbody id="online-tab${number}">`)
	var alarms_tbody = $(`<tbody id="alarms-tab${number}">`)
	var alarm_settings_tbody = $(`<tbody id="alarm-settings-tab${number}">`)
	var settings_tbody = $(`<tbody id="settings-tab${number}">`)
	var hw_settings_tbody = $(`<tbody id="hw-settings-tab${number}">`)
	online_tbody.append(`<tr class="table_header"><td class="name" colspan="2">${l100n.localize_string("Line")} ${number}</td></tr>`)
	online_tbody.append(form_tag_tr(l100n.localize_string("Name"), 0x5800 + 0x40*(number-1), 1));
	online_tbody.append(form_tag_tr(l100n.localize_string("Alarm Present"), 0x5801 + 0x40*(number-1), 1));
	online_tbody.append(form_tag_tr(l100n.localize_string("Actual Control Mode"), 0x5801 + 0x40*(number-1), 2));
	online_tbody.append(form_tag_tr(l100n.localize_string("Safe Mode"), 0x5801 + 0x40*(number-1), 3));
	online_tbody.append(form_tag_tr(l100n.localize_string("Output State"), 0x5801 + 0x40*(number-1), 4));
	online_tbody.append(form_tag_tr(l100n.localize_string("Contactor State"), 0x5801 + 0x40*(number-1), 7));
	online_tbody.append(`<tr class="table_header"><td colspan="2">${l100n.localize_string("Control")}</td></tr>`)
	online_tbody.append(form_tag_tr(l100n.localize_string("Trip Reset"), 0x5820 + 0x40*(number-1), 1));
	online_tbody.append(form_tag_tr(l100n.localize_string("Remote Output"), 0x5820 + 0x40*(number-1), 2));
	online_tbody.append(`<tr class="table_header"><td colspan="2">${l100n.localize_string("Temperature PV")}</td></tr>`)
	online_tbody.append(form_tag_tr(l100n.localize_string("Process Temperature"), 0x5810 + 0x40*(number-1), 1));
	online_tbody.append(form_tag_tr(l100n.localize_string("Temperature 1"), 0x5810 + 0x40*(number-1), 2));
	online_tbody.append(form_tag_tr(l100n.localize_string("Temperature 2"), 0x5810 + 0x40*(number-1), 3));
	online_tbody.append(`<tr class="table_header"><td colspan="2">${l100n.localize_string("Current PV")}</td></tr>`)
	online_tbody.append(form_tag_tr(l100n.localize_string("Load Current"), 0x5811 + 0x40*(number-1), 1));
	online_tbody.append(form_tag_tr(l100n.localize_string("Leakage Current"), 0x5811 + 0x40*(number-1), 2));
	online_tbody.append(`<tr class="table_header"><td colspan="2">${l100n.localize_string("Misc PV")}</td></tr>`)
	online_tbody.append(form_tag_tr(l100n.localize_string("PWM Val"), 0x5814 + 0x40*(number-1), 1));
	online_tbody.append(form_tag_tr(l100n.localize_string("Output On Count"), 0x5814 + 0x40*(number-1), 2));
	online_tbody.append(form_tag_tr(l100n.localize_string("Running Hours"), 0x5814 + 0x40*(number-1), 3));
	alarms_tbody.append(`<tr class="table_header"><td>${l100n.localize_string("Temperature Alarms")}</td>
		<td colspan="2">${l100n.localize_string("Alarm")}</td><td colspan="2">${l100n.localize_string("Trip")}</td></tr>`)
	alarms_tbody.append(form_tag_tr(l100n.localize_string("Process Temperature Fault"), 0x5802 + 0x40*(number-1), 2));
	alarms_tbody.append(form_tag_tr(l100n.localize_string("Temperature 1 Fault"), 0x5802 + 0x40*(number-1), 3));
	alarms_tbody.append(form_tag_tr2(l100n.localize_string("Temperature 1 High"), 0x5802 + 0x40*(number-1), 4, " ", 0x5807, 2));
	alarms_tbody.append(form_tag_tr(l100n.localize_string("Temperature 1 Low"), 0x5802 + 0x40*(number-1), 5));
	alarms_tbody.append(form_tag_tr(l100n.localize_string("Temperature 2 Fault"), 0x5802 + 0x40*(number-1), 6));
	alarms_tbody.append(form_tag_tr2(l100n.localize_string("Temperature 2 High"), 0x5802 + 0x40*(number-1), 7, " ", 0x5807, 3));
	alarms_tbody.append(form_tag_tr(l100n.localize_string("Temperature 2 Low"), 0x5802 + 0x40*(number-1), 8));
	alarms_tbody.append(`<tr class="table_header"><td>${l100n.localize_string("Current Alarms")}</td>
		<td colspan="2">${l100n.localize_string("Alarm")}</td><td colspan="2">${l100n.localize_string("Trip")}</td></tr>`)
	alarms_tbody.append(form_tag_tr2(l100n.localize_string("Load Current High"), 0x5803 + 0x40*(number-1), 2, " ", 0x5808, 2));
	alarms_tbody.append(form_tag_tr(l100n.localize_string("Load Current Low"), 0x5803 + 0x40*(number-1), 3));
	alarms_tbody.append(form_tag_tr2(l100n.localize_string("Leakage Current High"), 0x5803 + 0x40*(number-1), 4, " ", 0x5808, 3));
	alarms_tbody.append(form_tag_tr(l100n.localize_string("Output Off Current High"), 0x5803 + 0x40*(number-1), 5));
	alarms_tbody.append(`<tr class="table_header"><td>${l100n.localize_string("Misc Alarms")}</td>
		<td colspan="2">${l100n.localize_string("Alarm")}</td><td colspan="2"></td></tr>`)
	alarms_tbody.append(form_tag_tr(l100n.localize_string("Misconfig"), 0x5806 + 0x40*(number-1), 2));
	alarms_tbody.append(form_tag_tr(l100n.localize_string("Circuitbreaker OF"), 0x5806 + 0x40*(number-1), 3));
	alarms_tbody.append(form_tag_tr(l100n.localize_string("Circuitbreaker SD"), 0x5806 + 0x40*(number-1), 4));
	alarms_tbody.append(form_tag_tr(l100n.localize_string("Contactor Fault"), 0x5806 + 0x40*(number-1), 5));
	alarm_settings_tbody.append(`<tr class="table_header"><td colspan="2">${l100n.localize_string("Temperature Trips Enable")}</td></tr>`)
	alarm_settings_tbody.append(form_tag_tr(l100n.localize_string("Temperature 1"), 0x5828 + 0x40*(number-1), 1));
	alarm_settings_tbody.append(form_tag_tr(l100n.localize_string("Temperature 2"), 0x5828 + 0x40*(number-1), 2));
	alarm_settings_tbody.append(`<tr class="table_header"><td colspan="2">${l100n.localize_string("Current Trips Enable")}</td></tr>`)
	alarm_settings_tbody.append(form_tag_tr(l100n.localize_string("Load Current High"), 0x5829 + 0x40*(number-1), 1));
	alarm_settings_tbody.append(form_tag_tr(l100n.localize_string("Leakage Current High"), 0x5829 + 0x40*(number-1), 2));
	alarm_settings_tbody.append(`<tr class="table_header"><td colspan="2">${l100n.localize_string("Temperature Alarm Settings")}</td></tr>`)
	alarm_settings_tbody.append(form_tag_tr(l100n.localize_string("Temperature High"), 0x5822 + 0x40*(number-1), 1));
	alarm_settings_tbody.append(form_tag_tr(l100n.localize_string("Temperature Low"), 0x5822 + 0x40*(number-1), 2));
	alarm_settings_tbody.append(`<tr class="table_header"><td colspan="2">${l100n.localize_string("Current Alarm Settings")}</td></tr>`)
	alarm_settings_tbody.append(form_tag_tr(l100n.localize_string("Load Current High"), 0x5823 + 0x40*(number-1), 1));
	alarm_settings_tbody.append(form_tag_tr(l100n.localize_string("Load Current Low"), 0x5823 + 0x40*(number-1), 2));
	alarm_settings_tbody.append(form_tag_tr(l100n.localize_string("Leakage Current High"), 0x5823 + 0x40*(number-1), 3));
	alarm_settings_tbody.append(form_tag_tr(l100n.localize_string("Output Off Current High"), 0x5823 + 0x40*(number-1), 4));
	alarm_settings_tbody.append(`<tr class="table_header"><td colspan="2">${l100n.localize_string("Misc Alarm Settings")}</td></tr>`)
	alarm_settings_tbody.append(form_tag_tr(l100n.localize_string("Alarm Hold Time"), 0x5826 + 0x40*(number-1), 1));
	settings_tbody.append(`<tr class="table_header"><td colspan="2">${l100n.localize_string("Settings")}</td></tr>`)
	settings_tbody.append(form_tag_tr(l100n.localize_string("alarm_enable"), 0x5821 + 0x40*(number-1), 1))
	settings_tbody.append(form_tag_tr(l100n.localize_string("Startup Delay"), 0x5821 + 0x40*(number-1), 2))
	settings_tbody.append(form_tag_tr(l100n.localize_string("Control Mode"), 0x5821 + 0x40*(number-1), 3))
	settings_tbody.append(form_tag_tr(l100n.localize_string("Safe Mode"), 0x5821 + 0x40*(number-1), 4))
	settings_tbody.append(`<tr class="table_header"><td colspan="2">${l100n.localize_string("PWM")}</td></tr>`)
	settings_tbody.append(form_tag_tr(l100n.localize_string("PWM Period"), 0x5821 + 0x40*(number-1), 5))
	settings_tbody.append(form_tag_tr(l100n.localize_string("PWM Duty Cycle"), 0x5821 + 0x40*(number-1), 6))
	settings_tbody.append(`<tr class="table_header"><td colspan="2">${l100n.localize_string("Temp Relay")}</td></tr>`)
	settings_tbody.append(form_tag_tr(l100n.localize_string("Process Temperature Calc Mode"), 0x5821 + 0x40*(number-1), 7))
	settings_tbody.append(form_tag_tr(l100n.localize_string("Allow Incomplete Sensors"), 0x5821 + 0x40*(number-1), 8))
	settings_tbody.append(form_tag_tr(l100n.localize_string("Process Temp Set-point"), 0x5821 + 0x40*(number-1), 9))
	settings_tbody.append(form_tag_tr(l100n.localize_string("Hysteresis Positive"), 0x5821 + 0x40*(number-1), 10))
	settings_tbody.append(form_tag_tr(l100n.localize_string("Hysteresis Negative"), 0x5821 + 0x40*(number-1), 11))
	settings_tbody.append(`<tr class="table_header"><td colspan="2">${l100n.localize_string("PWM Proportional")}</td></tr>`)
	settings_tbody.append(form_tag_tr(l100n.localize_string("Proportional High Temp"), 0x5821 + 0x40*(number-1), 12))
	settings_tbody.append(form_tag_tr(l100n.localize_string("Proportional High PWM Duty Cycle"), 0x5821 + 0x40*(number-1), 13))
	settings_tbody.append(form_tag_tr(l100n.localize_string("Proportional Low Temp"), 0x5821 + 0x40*(number-1), 14))
	settings_tbody.append(form_tag_tr(l100n.localize_string("Proportional Low PWM Duty Cycle"), 0x5821 + 0x40*(number-1), 15))
	settings_tbody.append(`<tr class="table_header"><td colspan="2">${l100n.localize_string("HL DeadBand Settings")}</td></tr>`)
	settings_tbody.append(form_tag_tr(l100n.localize_string("Temperature Deadband Reference"), 0x582A + 0x40*(number-1), 1))
	settings_tbody.append(form_tag_tr(l100n.localize_string("Temperature Deadband"), 0x582A + 0x40*(number-1), 2))
	settings_tbody.append(form_tag_tr(l100n.localize_string("Current Deadband Reference"), 0x582A + 0x40*(number-1), 3))
	settings_tbody.append(form_tag_tr(l100n.localize_string("Current Deadband"), 0x582A + 0x40*(number-1), 4))
	settings_tbody.append(form_tag_tr(l100n.localize_string("Leakage Current Deadband Reference"), 0x582A + 0x40*(number-1), 5))
	settings_tbody.append(form_tag_tr(l100n.localize_string("Leakage Current Deadband"), 0x582A + 0x40*(number-1), 6))
	hw_settings_tbody.append(`<tr class="table_header"><td colspan="2">${l100n.localize_string("HW Settings")}</td></tr>`)
	hw_settings_tbody.append(form_tag_tr(l100n.localize_string("Minimum Output Hold Time"), 0x582B + 0x40*(number-1), 1))
	hw_settings_tbody.append(form_tag_tr(l100n.localize_string("Output Select"), 0x582B + 0x40*(number-1), 2))
	hw_settings_tbody.append(`<tr class="table_header"><td colspan="2">${l100n.localize_string("Input Select")}</td></tr>`)
	hw_settings_tbody.append(form_tag_tr(l100n.localize_string("Temperature 1 Input"), 0x582B + 0x40*(number-1), 3))
	hw_settings_tbody.append(form_tag_tr(l100n.localize_string("Temperature 2 Input"), 0x582B + 0x40*(number-1), 4))
	hw_settings_tbody.append(form_tag_tr(l100n.localize_string("Load Current"), 0x582B + 0x40*(number-1), 5))
	hw_settings_tbody.append(form_tag_tr(l100n.localize_string("Leakage Current"), 0x582B + 0x40*(number-1), 6))
	hw_settings_tbody.append(form_tag_tr(l100n.localize_string("Circuitbreaker OF"), 0x582B + 0x40*(number-1), 7))
	hw_settings_tbody.append(form_tag_tr(l100n.localize_string("Circuitbreaker SD"), 0x582B + 0x40*(number-1), 8))
	hw_settings_tbody.append(form_tag_tr(l100n.localize_string("Contactor State"), 0x582B + 0x40*(number-1), 9))

	var table = $('<table class="line-params-table">')
	table.append(online_tbody).append(alarms_tbody).append(alarm_settings_tbody).append(settings_tbody).append(hw_settings_tbody)
	var tabs_div = $('<div class="tab-class">').append(ul).append(table)
	var body_div = $('<div class="accordion-body">').append(tabs_div)
	return body_div
}

function response_ready()
{
	var types = get_board_types()
	types.shift()
	show_boards_by_type(types)
	$("#boyan").accordion({ heightStyle: 'content', header: '.accordion-header', active: 0});
    $("#boyan").accordion( "option", "collapsible", true );
	user.parse_page()

	$('.can_hide').each(function( index )
	{
		var form = $(this).children('.value_td').children('.tag').children('.apply_form')
		if ($(form).hasClass('empty')) { $(this).hide() }
	});
	$("div[index='1001:0']").hide()
	$(".tab-class").tabs();
}

function get_board_types()
{
	var response_values = [];
	var responseLines = get_board_type_xhr.responseText.split('\n');
	var responseLine = responseLines[1];
	//console.log("responseLine:"+responseLine);
	/*if ((responseLines[1].search( />>>ERROR<<</i ) != -1) || (responseLines[1].search( /!!!ERROR!!!/i ) != -1))
    {
        alert('Ошибка в ответе с сервера:' + responseLine);
    }*/

    response_values = responseLine.split('&#&');
    response_values.pop();
    //console.log('response_values: ' + response_values);
    return response_values;
}

$(document).on('click', '.accordion-header', function()
{
    selected_accordion = $(this).index();
});

$(document).on('value_loaded', 'div[tb_index="1001_0"]', function( e )
{
    var device_error = $(this).text()
    if (device_error > 0)
    {
        $('.device_status').addClass('device_error')
    }
    else
    {
        $('.device_status').removeClass('device_error')
    }

    $(this).removeClass('value_loaded')
});

$(document).on('value_loaded', '.board_status', function( e )
{
    var board = $(this).children('form').children('div.value')
    var board_error = board.text()
    var status_index = $(this).attr('index')
    if (board_error > 0)
    {
        $(`div[status_index="${status_index}"]`).addClass('device_error')
    }
    else
    {
        $(`div[status_index="${status_index}"]`).removeClass('device_error')
    }

    //$(this).removeClass('board_error')
    $(this).removeClass('value_loaded')
});

get_board_type_xhr.onreadystatechange = function()
{
    //console.log(get_board_type_xhr.readyState);
    if (get_board_type_xhr.readyState == 4)
    {
        if (get_board_type_xhr.status == 200)
        {
            response_ready();
        }
        else
        {
            alert("Проверьте соединение с контроллером...");
        }
    }
}
